VERSION 5.00
Begin VB.Form form_main 
   BackColor       =   &H00C0FFFF&
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Cursor Clock Main Form"
   ClientHeight    =   645
   ClientLeft      =   30
   ClientTop       =   600
   ClientWidth     =   2190
   ControlBox      =   0   'False
   Icon            =   "CursorClock.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   645
   ScaleWidth      =   2190
   ShowInTaskbar   =   0   'False
   Begin VB.Timer Timer1 
      Enabled         =   0   'False
      Interval        =   1000
      Left            =   120
      Top             =   120
   End
   Begin VB.Menu popup 
      Caption         =   "Tray popup"
      Begin VB.Menu popup_format_12 
         Caption         =   "12-hour clock"
      End
      Begin VB.Menu popup_format_24 
         Caption         =   "24-hour clock"
         Checked         =   -1  'True
      End
      Begin VB.Menu popup_about 
         Caption         =   "About Cursor Clock..."
      End
      Begin VB.Menu popup_exit 
         Caption         =   "Exit Cursor Clock"
      End
   End
End
Attribute VB_Name = "form_main"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Dim TrayIcon As New NotifyIcon
Dim CursorClockInstance As New CursorClock
'Private Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long)



'Problem: by default, a popup menu should disappear when the user clicks outside
'of the popup menu; however, if the popup menu was opened while the parent
'form did not have focus then the popup menu will not diappear as expected.
'1. In order to make the popup menu disppear when the user clicks ouside of the
'   popup menu the parent form must have focus.
'2. In order to have focus a form must be visible.
'3. In Cursor Clock the main form should never be visible.
'The following function allows the parent form for have focus,
'yet remain invisible. This works simply by moving the form off
'the visible screen. The system thinks the window is visible, but the user
'cannot see it.
Private Sub HiddenFocus(target_form As Form)
    target_form.Width = 0
    target_form.Height = 0
    'Position form off-screen
    target_form.Left = -1000
    target_form.Top = -1000
    target_form.Show
    target_form.SetFocus
End Sub
Private Sub END_APPLICATION()
    Timer1.Enabled = False
    TrayIcon.Delete
    Unload form_about
    Unload form_main
    CursorClockInstance.CursorFinished
    End
End Sub
Private Sub Form_Load()
    'Make sure the clock isn't running. Defensive programming...
    Timer1.Enabled = False
        
    'If a previous instace is running then quit this new instance.
    If App.PrevInstance = True Then
        END_APPLICATION
    End If
    
    'Save the old system cursor. This is used to
    'restore the system cursor during QueryUnload event.
    CursorClockInstance.CursorStart
    
    'Stealth Mode.
    '1. Set icon to appear in notify icon taskbar tray.
    '2. Remove normal icon from normal taskbar.
    '3. Hide main form so it cannot be seen.
    TrayIcon.Add Me, "Cursor Clock"
    App.TaskVisible = False
    Hide
    
    'Set process priority to be low.
    Dim current_process As Long
    current_process = GetCurrentProcess()
    popup_exit.Checked = Not CBool(SetPriorityClass(current_process, IDLE_PRIORITY_CLASS))
    
    'Restore settings from registry
    If GetSetting("Cursor Clock 1 Noah", "settings", "time format") = "24" Then
        CursorClockInstance.SetHourFormat24
        popup_format_12.Checked = False
        popup_format_24.Checked = True
    Else
        popup_format_12.Checked = True
        popup_format_24.Checked = False
        CursorClockInstance.SetHourFormat12
    End If
    
    'Initialize the cursor to display time immediately after starting.
    CursorClockInstance.SetSystemCursorToCurrentTime

    'Synchronize timer so it fires just after the system time minute.
    'Do this by waiting until the current time minute is over
    'before starting the main timer. This will sync within 5 seconds after
    'the minute.
    Do While (CLng(Second(Now)) > 5) Or (CLng(Second(Now)) < 1)
        DoEvents
    Loop
'I didn't use the following sync code because this didn't allow events,
'so it could make the application appear to hang for up to one minute
'before starting. I don't want to give the appearance that it has crashed.
'Some people just can't wait a minute before they start hitting
'CTRL-ALT-DEL (including your's truly).
'    Dim ms As Long
'    ms = 1000 * (60 - CLng(Second(Now)) + 1)
'    Sleep ms
    
    'Start the main timer.
    Timer1.Interval = 60000 'One minute
    Timer1.Enabled = True
End Sub


Private Sub Form_QueryUnload(Cancel As Integer, UnloadMode As Integer)
    END_APPLICATION
End Sub
'TrayIcon sends MouseMove messages to the associated form.
Private Sub Form_MouseMove(Button As Integer, Shift As Integer, x As Single, y As Single)
    Dim message As Long
    Static static_lock As Boolean

    'Shell_NotifyIcon in the Windows API encodes the
    'button clicks in the x parameter of the MouseMove event.
    message = TrayIcon.DecodeMessage(x)
    
    If static_lock = False Then
        static_lock = True
        Select Case message
            ' Left double click
            Case TrayIcon.WM_LBUTTONDBLCLK
                HiddenFocus Me
                PopupMenu popup, vbPopupMenuLeftButton
                Hide
            ' Right button up
            Case TrayIcon.WM_RBUTTONUP
                HiddenFocus Me
                PopupMenu popup, vbPopupMenuRightButton Or vbPopupMenuLeftButton
                Hide
        End Select
        static_lock = False
    End If
End Sub

Private Sub popup_about_Click()
'Normally about dialog boxes are modal, but a modal dialog will
'cause the popup menu to get locked until the about dialog is closed.
'This is not usually a problem, but sometimes the user will click a
'differnt application and the about dialog will get "burried" under other
'windows. This can confuse the user because they cannot get the popup menu
'to open, yet they cannot see that there is an open modal dialog box.
'The solution to this problem is to make the dialog modeless and then
'automatically close the dialog if the user clicks on a differnt form.
'See the Form_Deactivate event on the form_about form. This event is sent
'to a modeless dialog when the user clicks on a different window in the
'same application.
    form_about.Show vbModeless, Me
End Sub

Private Sub popup_exit_Click()
    END_APPLICATION
End Sub

Private Sub popup_format_12_Click()
    SaveSetting "Cursor Clock 1 Noah", "settings", "time format", "12"
    popup_format_12.Checked = True
    popup_format_24.Checked = False
    CursorClockInstance.SetHourFormat12
    CursorClockInstance.SetSystemCursorToCurrentTime
End Sub

Private Sub popup_format_24_Click()
    SaveSetting "Cursor Clock 1 Noah", "settings", "time format", "24"
    popup_format_12.Checked = False
    popup_format_24.Checked = True
    CursorClockInstance.SetHourFormat24
    CursorClockInstance.SetSystemCursorToCurrentTime
End Sub


Private Sub Timer1_Timer()
    CursorClockInstance.SetSystemCursorToCurrentTime
End Sub
